(* 	Per come sono strutturati gli operatori  necessario inserire la lista
	in input al _contrario_ partendo quindi dall'ultimo elemento fino al primo *)
Program dupTre;

type	lista = ^cella;
	posizione = lista;

	cella = record
		precedente : posizione;
		elemento : integer;
		successivo : posizione
	end;

var	L, M : lista;
	pos, inizio : posizione;
	numero : integer;

Procedure CREALISTA (var L:lista);
Begin
	new(L);
	L^.successivo := L;
	L^.precedente := L
End;

function LISTAVUOTA (var L:lista) : boolean;
Begin
	LISTAVUOTA := (L^.successivo = L) and (L^.precedente = L)
End;

function PRIMOLISTA (var L:lista) : posizione;
Begin
	PRIMOLISTA := L^.successivo
End;

function ULTIMOLISTA (var L:lista) : posizione;
Begin
	ULTIMOLISTA := L^.precedente
End;

function SUCCLISTA (p:posizione; var L:lista) : posizione;
Begin
	SUCCLISTA := p^.successivo
End;

function PREDLISTA (p:posizione; var L:lista) : posizione;
Begin
	PREDLISTA := p^.precedente
End;

function FINELISTA (p:posizione; var L:lista) : boolean;
Begin
	FINELISTA := (p = L)
End;

function LEGGILISTA (p:posizione; var L:lista) : integer;
Begin
	LEGGILISTA := p^.elemento
End;

procedure SCRIVILISTA (a:integer; p:posizione; var L:lista);
Begin
	p^.elemento := a
End;

procedure INSLISTA (a:integer; var p:posizione; var L:lista);
var	temp : posizione;
Begin
	new(temp);
	temp^.precedente := p^.precedente;
	temp^.successivo := p;
	p^.precedente^.successivo := temp;
	p^.precedente := temp;
	temp^.elemento := a;
	p := temp
End;

procedure CANCLISTA(var p:posizione; var L:lista);
var	temp : posizione;
Begin
	temp := p;
	p^.precedente^.successivo := p^.successivo;
	p^.successivo^.precedente := p^.precedente;
	p := p^.successivo;
	dispose(temp)
End;

(* stampa a video il contenuto della lista *)
procedure DUMP(var L:lista);
var pos : posizione;
Begin
	pos := PRIMOLISTA(L);
	while pos <> ULTIMOLISTA(L)  do
	Begin
		write(LEGGILISTA(pos ,L), ' ');
		pos := SUCCLISTA(pos, L)
	End;

	writeln(LEGGILISTA(pos ,L))
End;

procedure DUPLICA3(var L : lista);
var 	p : posizione;
	a : integer;

Begin
	p := PRIMOLISTA(L);

	while not FINELISTA(p, L) do Begin
		a := LEGGILISTA(p, L);

		if (a mod 3) = 0 then begin
			p := SUCCLISTA(p, L);
			INSLISTA(a, p, L)
		end;
		
		p := SUCCLISTA(p, L)
	end
End;

Begin
	numero := 0;

	CREALISTA(L);
	pos := PRIMOLISTA(L);

	while numero >= 0 do
        Begin
                Write('Numero da inserire: ');
                Readln(numero);

                if (numero >= 0) then	
		Begin
			INSLISTA(numero, pos, L); 
(*			writeln(LEGGILISTA(PRIMOLISTA(L),L), ' ', LEGGILISTA(ULTIMOLISTA(L),L));*)

		End
        End;

	
	DUMP(L);

	DUPLICA3(L);

	DUMP(L)
End.
